Subject: Re: bug#62333: 30.0.50; Issue with tree-sitter syntax tree during certain changes

From: Eli Zaretskii <[email-masked]>
Date: Wed, 29 Mar 2023 14:08:31 +0300

> Date: Wed, 29 Mar 2023 00:08:53 +0300
> Cc: [email-masked], [email-masked], [email-masked],
>  [email-masked]
> From: Dmitry Gutov <[email-masked]>
> 
> >> Is that because we don't think the user level narrowing is done purely
> >> for visual effect?
> > 
> > Indeed, it isn't always for visual effect.
> 
> When isn't it? Is there a way to determine that from code?

I'm not sure I understand the question, but if I do, then narrowing to
prevent search functions and commands from finding irrelevant hits is
one example that comes to mind.

> >> judging by regular user requests for make this or that command
> >> ignore user-level narrowing, it seems like "purely visual" should be the
> >> default interpretation.
> > 
> > I think you base your judgment on feedback from users who are not used
> > to take advantage of narrowing in editing.  I think most young people
> > aren't, since this feature is more-or-less unique to Emacs.
> 
> Either narrowing should be used to change lexical/grammatical/etc 
> context, or it should not. Do we have any documentation that says one or 
> the other way? That should affect how Lisp code deals with narrowing -- 
> which interactive functions should widen, and so on.

I was talking about user commands that narrow, so I'm not sure I
understand how documentation could help.  When the user types "C-x n n",
there's nothing Emacs can do except obey.